from pathlib import Path

PROJ = Path("/lustre/S/nanziyuan/projects/llmtest")
EXP = PROJ / "exps"

def merge_jsonl(completion_path, target_path):
    dir = Path(completion_path)
    with open(target_path / "samples.jsonl", "w") as outfile:
        for f in dir.glob("*.jsonl"):
            print(f)
            with open(f, "r") as infile:
                outfile.write(infile.read())

def mk_eval(exp_path):
    exp_path = Path(exp_path)
    name = exp_path.stem
    eval_path = EXP / f"{name}-test"
    eval_path.mkdir()
    completion_path = exp_path / "completion"
    merge_jsonl(completion_path, eval_path)

    testset = name.split('-')[1]
    if testset == "humaneval":
        test_program = [f"cd {eval_path.absolute()}",
                        "evalplus.evaluate --dataset humaneval --samples samples.jsonl"]
    else:
        raise NotImplementedError(f"Unknown testset: {testset})")

    test_program = "\n".join(test_program)

    with open("cpu.slurm.template", "r") as f:
        template = f.read()

    with open(eval_path / "cpu.slurm", "w") as f:
        f.write(template.format(name=name, test_program=test_program))
